//====----------------------- --- --   -      -
// MULTIUSER NETWORK MANAGEMENT
// TCP/IP and UDP support.
// 2000-2002, Vander Nunes
//======----------------------------- --- --   -      -

// ------------------------------------------------------------------------------------------
// applications using net classes should include netserver.h and/or netclient.h
// ------------------------------------------------------------------------------------------

#ifndef _NET_H_

  #define _NET_H_
  #include <windows.h>

  // include wsock32.lib in the link
  #pragma comment (lib, "wsock32.lib")

  // type of socket
  enum enSockType { stUDP, stTCP };

  // a network packet
  typedef struct _NETPACKET
  {
    void   *pBuffer;
    int    iLength;
  } NETPACKET;

  // ----------------------------------------------------------------------------------------------
  // Net Events - most will be repassed to the user's callback
  // ----------------------------------------------------------------------------------------------

  // internal use
  #define NET_SELECT        WM_USER+10

  // internal use by resolver
  #define NET_RESOLVE       WM_USER+11

  // new incoming connection
  #define NET_NEWCONNECTION WM_USER+20

  // new outcoming connection
  #define NET_CONNECTED     WM_USER+21

  // new data waiting
  #define NET_NEWDATA       WM_USER+22

  // client disconnection
  #define NET_DISCONNECTION WM_USER+23

  // refused incoming connection
  #define NET_REFCONNECTION WM_USER+24

  // ----------------------------------------------------------------------------------------------


  // ------------------------------------------------------------------------------------------
  // this is a private function used by CNetServer and CNetClient classes.
  // ------------------------------------------------------------------------------------------

  HWND NetMakeWindow(const char *szTitle, DWORD dwRefCount, int iWidth, int iHeight, DWORD dwFlags, WNDPROC hWndProc);

#endif
